# Convert levels from svg into simpler format.
$filename = $ARGV[0];
open F, "<$filename" or die;
$polys = 0;
$polytext = '';
while ($line = <F>) {
	if ($line =~ /path d=\"(.*?)\"/) {
		$stuff = $1;
		# print "$stuff\n";
		@bits = split(/ +/,$stuff);
		$i=0;
		$points = 0;
		$coords = '';
		$finished = 0;
		@xco = ();
		@yco = ();
		do {
			$junk = $bits[$i++];
			$x = $bits[$i++];
			$y = $bits[$i++];
			$i += 4; # Ignore bezier stuff
			if ($x) {
				$xco[$points] = int($x);
				$yco[$points] = int($y);
				$points++;
			} else {
				$finished = 1;
			}
		} while ($i < $#bits);
		if ($points > 3) {
			$polys ++;
			# Remove one point because it's a repeat.
			$points --;
			# Check if clockwise
			if (! IsClockwise()) {
				print STDERR  "Anticlock\n";
				@xco = reverse @xco;
				@yco = reverse @yco;
			} else {
				print STDERR  "Clock\n";
			}
			$polytext = $polytext . "$points ";
			for ($i=0; $i<$points; $i++) {
				$polytext = $polytext . "$xco[$i] $yco[$i] ";
			}
			$polytext = $polytext . "\n";
		}
	}
}
close F;
print "$polys\n";
print $polytext;

# Determine whether the polygon in xco and yco arrays
# goes clockwise
sub IsClockwise
{
	my ($dx1, $dy1, $dx2, $dy2);
	($dx1,$dy1) = ($xco[1] - $xco[0], $yco[1] - $yco[0]);
	($dx2,$dy2) = ($xco[2] - $xco[1], $yco[2] - $yco[1]);
	# Rotate d1 around clockwise 90 degrees
	($dx1, $dy1) = (-$dy1, $dx1);
	# dot prod with d2
	my ($prod) = ($dx1 * $dx2) + ($dy1 * $dy2);
	# Result is positive? We're going clockwise
	return ($prod > 0);	
}
